package emst.algorithm;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

import emst.ds.Edge;
import emst.ds.Graph;
import emst.ds.Vertex;

public class RandomWalk {

	public static Graph randomWalk(int numberOfIterations) {
		Random random = new Random();
		
		List<Vertex> vertices = new ArrayList<Vertex>();
		List<Edge> edges = new ArrayList<Edge>();
		
		// We always start at 0,0,0
		Vertex previousVertex = new Vertex("v0", new Float[]{0f, 0f, 0f});
		vertices.add(previousVertex);

		for (int i = 0; i < numberOfIterations; i++) {
			
			Float coords[];
			coords = Arrays.copyOf(previousVertex.getCoordinates(), 3);
			
			int axis = random.nextInt(3);
			
			boolean positive = random.nextBoolean();
						
			coords[axis] = coords[axis] + (positive?0.5f:-0.5f);
			
			Vertex v = new Vertex("v" + i, coords);
			
			Edge e = new Edge("e" + i, previousVertex, v);
			edges.add(e);
			
			vertices.add(v);
			previousVertex = v;
		}
		
		/*for (Vertex v : vertices) {
			int numberOfEdgesToMake = (int)(random.nextFloat() * (vertices.size()/ (vertices.size() /10)));
			
			for (int i = 0; i < numberOfEdgesToMake; i++) {
				int vertexIndex = random.nextInt(vertices.size());
				Vertex v2 = vertices.get(vertexIndex);
				Edge e = new Edge("e" + i, v, v2);
				edges.add(e);
			}
		} */
		
		Graph graph = new Graph(vertices, edges, "Random Walk");
		
		//graph.cleanUpGraph();
		
		return graph;
		
	}
	
}
