package emst.algorithm;

import java.util.HashMap;
import java.util.List;

import emst.ds.Edge;
import emst.ds.Graph;
import emst.ds.Vertex;

/**
 * Verifies a list of edges creates a spanning tree by visiting all edges. does not check for cycles.
 * @author Ben
 *
 */
public class VerifyST {

	public static boolean check(List<Edge> tree, Graph graph) {
		HashMap<String, Boolean> vertexMap = new HashMap<String, Boolean>();
		for (Vertex v : graph.getVertices()) {			
			vertexMap.put(v.getName(), Boolean.FALSE);			
		}
		for (Edge e : tree) {
			vertexMap.put(e.getV1().getName(), Boolean.TRUE);
			vertexMap.put(e.getV2().getName(), Boolean.TRUE);			
		}
		for (Boolean b : vertexMap.values()) {
			if (b == false)
				return false;
		}
		return true;
		
	}
	
}
