package emst.ds;

import java.util.Arrays;

public class Vertex {

	protected String name;
	
	protected Float coordinates[];

	public Vertex(String name, Float[] coordinates) {
		this.name = name;
		this.coordinates = coordinates;
	}

	public Float[] getCoordinates() {
		return coordinates;
	}

	public void setCoordinates(Float[] coordinates) {
		this.coordinates = coordinates;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("Vertex: ").append(name==null?"null":name).append(" ");
		
		for (Float el : coordinates) {
			builder.append(el);
			builder.append(" ");
		}
		
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Arrays.hashCode(coordinates);
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Vertex other = (Vertex) obj;
		if (!Arrays.equals(coordinates, other.coordinates))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	
	public boolean sameCoordinates(Vertex v) {
		if (v.getCoordinates().length != coordinates.length)
			return false;
		
		for (int i = 0; i < coordinates.length; i++) {
			if (v.getCoordinates()[i].floatValue() != coordinates[i].floatValue())
				return false;
		}
		
		return true;
	}
	
	
	
}
