package emst;

import java.io.File;
import java.io.IOException;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import org.junit.Test;

import emst.ds.Edge;
import emst.ds.Graph;
import emst.util.Ms3dReader;

public class BoxMs3dTest {
	
	private static final Logger logger = Logger.getLogger(BoxMs3dTest.class);
	
	@Test
	public void testBox() throws IOException {

		
		
		BasicConfigurator.configure();
		
		File file = new File("sample/box_ms3d.txt");
		
		Graph graph = Ms3dReader.readFile(file);
		System.out.println(graph.getName());
		System.out.println("Edges: " + graph.getEdges().size());
	
		/*for (Vertex v : graph.getVertices()) {
			graph.findIncidentEdges(v);
		}
		
		graph.removeDuplicateEdges();

		logger.debug("With duplicate edges removed.");
		
		for (Vertex v : graph.getVertices()) {
			graph.findIncidentEdges(v);
		} */
		
		logger.debug("Showing vertices with duplicate coordinates.");
		
		logger.debug("\n" + graph.formatDuplicateVerticesInGraph());
		
		graph.mergeAllDuplicateVertices();
		
		logger.debug("With duplicate coordinates merged.");
		
		logger.debug("\n" + graph.formatDuplicateVerticesInGraph());
		
		StringBuilder b = new StringBuilder();
		for (Edge e : graph.getEdges()) {
			b.append(e.toShortString());
			b.append("\n");
			
		}
		
		logger.debug("Remaining Edges: \n" + b.toString());
		
		graph.removeDuplicateEdges();
		
		b = new StringBuilder();
		for (Edge e : graph.getEdges()) {
			b.append(e.toShortString());
			b.append("\n");
			
		}
		
		logger.debug("Removed duplicate edges: \n" + b);
	}
}
