package emst;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.junit.Test;

import emst.algorithm.Kruskal;
import emst.ds.Edge;
import emst.ds.Graph;
import emst.util.Ms3dReader;

public class CylinderMs3dTest {

	@Test
	public void testCylinder() throws IOException {
		File file = new File("sample/cylinder_ms3d.txt");
		
		Graph graph = Ms3dReader.readFile(file);
		System.out.println(graph.getName());
		System.out.println("Edges: " + graph.getEdges().size());;
		
		List<Edge> mst = Kruskal.mst(graph);
		
		System.out.println("Number of edges in MST: " + mst.size());
		
		
	}
}
